/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package modcompuapli;

import java.io.File;
import java.util.Collection;
import java.util.List;
import javax.swing.table.DefaultTableModel;
import lius.LiusLogger;
import lius.config.LiusConfig;
import lius.config.LiusConfigBuilder;
import lius.config.LiusDocumentProperty;
import lius.config.LiusField;
import lius.index.Indexer;
import lius.index.IndexerFactory;
import lius.search.LiusHit;
import lius.search.LiusHitList;
import lius.search.SearchIndex;

/**
 *
 * @author ivan
 */
public class IndexadorMC {

    // Directorio donde se creara el índice de Lucene
    private String indexDir = "E:\\PROY\\indices";
    // Localización del fichero de configuración de LOG4J
    private String log4jFile = "E:\\PROY\\Config\\log4j\\log4j.properties";
    // Localización del fichero de configuración de Lius
    private String configFile = "E:\\PROY\\Config\\liusConfig.xml";
    private String ficherosIndexar = "E:\\PROY\\EjemplosTest";
    private LiusConfig config;
    private String logfinal = "";

    /**
     * @param args the command line arguments
     */
    public IndexadorMC(String fich1, String fich2, String fich3, String fich4) {
        indexDir = fich1;
        log4jFile = fich2;
        configFile = fich3;
        ficherosIndexar = fich4;
    }

    /**
     *
     */
    public String indexar(String fich1, String fich2, String fich3, String fich4) throws Exception {
        indexDir = fich3;
        log4jFile = fich1;
        configFile = fich2;
        ficherosIndexar = fich4;
        // Inicializamos LOG4J
        System.out.println(log4jFile);
        LiusLogger.setLoggerConfigFile(log4jFile);
        // Leemos el fichero de configuración de Lius
        config = LiusConfigBuilder.getSingletonInstance().
                getLiusConfig(configFile);

        // Recorremos los ficheros del directorio docs
        File filesDir = new File(ficherosIndexar);
        File[] files = filesDir.listFiles();
        for (File file : files) {
            // Indexamos el fichero
            index(file);
        }
        return (logfinal);
    }

    public DefaultTableModel buscar(DefaultTableModel modelo, String busqueda, String fich1, String fich2, String fich3, String fich4) throws Exception {
        indexDir = fich3;
        log4jFile = fich1;
        configFile = fich2;
        ficherosIndexar = fich4;
        DefaultTableModel sc;
        sc = modelo;
        for(int j=0;j<sc.getRowCount();j++) sc.removeRow(j);

       
        LiusLogger.setLoggerConfigFile(log4jFile);
        config = LiusConfigBuilder.getSingletonInstance().
                getLiusConfig(configFile);

        // Buscamos la cadena "institutionnel" en los campos configurados en liusConfig.xml
        LiusHitList ls = SearchIndex.search(busqueda,
                indexDir, configFile);

        System.out.println("Numero de documentos hallados = " + ls.size());
        for (int i = 0; i < ls.size(); i++) {
            LiusHit lh = (LiusHit) ls.get(i);
            System.out.println("--- Documento " + i + " ---");
            float puntuacion = (float) lh.getScore();
            System.out.println("Puntuacion    = " + puntuacion);
            System.out.println("Identificador = " + lh.getDocId());
            if(lh.getScore() > 0.001){
            Object[] data = new Object[2];
            data[0] = lh.getDocId()+1;
            data[1] = puntuacion;
            sc.addRow(data);
            }
            
            List liusHitFields = lh.getLiusFields();
            for (int j = 0; j < liusHitFields.size(); j++) {
                LiusField lf = (LiusField) liusHitFields.get(j);
                String name = lf.getLabel();
                String[] values = lf.getValues();
                System.out.print(name + " : ");
                for (int k = 0; k < values.length; k++) {
                    System.out.println("\t" + values[k]);
                }
            }
            System.out.println("---------------------");
        }
        
        return(sc);
    }

    // Método para indexar ficheros
    private void index(File file) {
        log("-------------------------------------------------");
        log("FICHERO:    " + file.getName());
        Indexer indexer = IndexerFactory.getIndexer(file, config);
        debug(indexer);
        indexer = IndexerFactory.getIndexer(file, config);
        indexer.index(indexDir);
    }

    // Metodo para volcar información de depuración por pantalla
    private void log(String msg) {
        logfinal += msg + "\n";
        System.out.println(msg);
    }

    // Metodo para volcar la información obtenida de un indexador
    private void debug(Indexer indexer) {
        //log("INDEXADOR: " + indexer.getClass().getName());
        //log("CAMPOS:  ");
        Collection c = indexer.getPopulatedLiusFields();
        for (Object o : c) {
            if (o instanceof LiusField) {
                // Campo Lucene
                LiusField o2 = (LiusField) o;
                System.out.println("  CAMPO: " + o2.getGet() + "."
                        + o2.getGetMethod() + " <" + o2.getName()
                        + "> = " + o2.getValue());
            } else if (o instanceof LiusDocumentProperty) {
                // Valor boost para el documento Lucene
                LiusDocumentProperty o2 = (LiusDocumentProperty) o;
                //log("  BOOST: " + o2.getBoost());
            } else {
                // Otros datos
                log("  " + o);
            }
        }
    }
}